#include <string>

// Returns true if path does not contain folder names (it consists only of filename).

bool IsFilenamePath(const std::string& path);

// Returns true if path is an absolute path.

bool IsAbsolutePath(const std::string& path);

// Splits fullname in path (*including* final (back)slash) and filename parts
// and returns them in dirname and basename, respectively.

void SplitFilename(const std::string& fullname, 
				   std::string& dirname, std::string& basename);

// Returns current working dir (always \ terminated) to cur_path. 
// May throw AvisynthError exceptions

void GetWorkingDir(std::string& cur_path);

// If new_path is not "", sets working dir to new_path.
// Expects new_path to end with a \ character.
// May throw AvisynthError exceptions.

void SetWorkingDir(const std::string& new_path);

// If fullname contains a folder part, changes working dir to it and returns
// old working dir to old_path, new working dir to new_path and the filename 
// part to basename.
// If fullname does *not* contain a folder part, no change is made and returns
// "" to old_path, "" to new_path and fullname to basename.
// Use SetWorkingDir(old_path) to restore the working dir.

void ChangeWorkingDir(const std::string& fullname, std::string& old_path, 
					  std::string& new_path, std::string& basename);
